<?php

namespace HAI\Includes;

class HAI_Connect_helios {

    protected $url;
    protected $token;
    protected $namespace;
    protected $rest_base;
    protected $params;
    protected $settings;
    protected $request;
    protected $postfields;

    public function __construct( string $rest_base ) {

        // $this->token = get_option( 'hai_api_token' );
        $dev_mode = HAI_ADMINURL_PREFIX;
        $this->url = "https://$dev_mode.heliosai.eu/wpapi/";

        $this->rest_base = $rest_base;
        $this->request = 'POST';

    }

    public function connect( $postfields ) {
        
        $logger = wc_get_logger();
        $logger->log( 'info', 'xxxxxx order_id: ' . json_encode($postfields) );

        $curl = curl_init();
    
        curl_setopt_array($curl, array(
            CURLOPT_URL => $this->url . $this->rest_base,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => $this->request,
            CURLOPT_POSTFIELDS => $postfields,
            // CURLOPT_HTTPHEADER => array(
            //     'Authorization: Bearer ' . $this->token,
            // ),
        ));
    
        $response = curl_exec($curl);
    
        curl_close($curl);

        $logger->log( 'info', 'response: ' . $response );
    
        return ( json_decode($response) );

    }
}