let hai_popup_ajax = false;
jQuery(document).ready(function($){

    /* Abandoned cart */

    window.hai_body = $( document.body );

    $('[name="billing_email"]').on('change', function(){
        function ajaxFrontendFormdata(formData, callback) {

            $.ajax({
                url: hai_ajax_object.ajax_url,
                type: 'POST',
                data: formData,
                cache: false,
                processData: false,
                contentType: false,
                success: function (data) {
                    callback(data);
                },
                error: function (data) {
                    console.log(data);
                }
            });
    
        }

        // Get the email value from the input field
        var billingEmail = $(this).val();

        // Create a FormData object and append the email value to it
        var fd = new FormData();
        fd.append('action', 'hai_abandoned_cart'); // Specify the action name for your backend handler
        fd.append('billing_email', billingEmail);

        // Make the AJAX request
        ajaxFrontendFormdata(fd, function(response) {
            // Handle the response from the backend
            console.log(response);
        });

    });

        /*FRAGMENT POPUP*/
        $(document.body).on('added_to_cart', function(a){
            if(typeof wc_cart_fragments_params !== 'undefined' && wc_cart_fragments_params.fragment_name && sessionStorage.getItem(wc_cart_fragments_params.fragment_name)){
                setTimeout(function(){
                    let wc_fragment = JSON.parse(sessionStorage.getItem(wc_cart_fragments_params.fragment_name));
                    if(wc_fragment['hai_popup']){
                    $(document.body).append(wc_fragment['hai_popup']);
                    var scriptContent = document.createElement('script');
                    scriptContent.text = wc_fragment['hai_popup_script'];
                    document.body.appendChild(scriptContent);
                    delete wc_fragment['hai_popup'];
                    delete wc_fragment['hai_popup_script'];
                    sessionStorage.setItem(wc_cart_fragments_params.fragment_name, wc_fragment);
                    hai_popup_script();
                    hai_popup_ajax = true;
                }
                }, 1000);
            }
        });

    if ($('.hai-widget').length > 0){

        $('.hai-widget').on('change', '.var_select', function(){
            let sel = $(this).find(':selected');
            $(this).closest('.haiWrapper').find('.hai-price-u').text(sel.data('uprice'));
            $(this).closest('.haiWrapper').find('.hai-price-wc').text(sel.data('wcprice'));
            checkPrices();
        });

        let price = parseFloat($('#hai_product_price').val());
    
        $('#hai-uprice').text(price);

        let checkedPricesU = [];
        let checkedPricesWc = [];
        let checkedProds = [];

        function checkPrices() {
            checkedPricesU = [];
            checkedPricesWc = [];
            checkedProds = [];

            $('.hai-widget input[type="checkbox"], button.add_to_cart_button').each(function() {
                if ($(this).is(':checked')) {
                    let priceU = parseFloat($(this).closest('.haiWrapper').find('.hai-price-u').text());
                    let priceWc = parseFloat($(this).closest('.haiWrapper').find('.hai-price-wc').text());
                    let prodId = parseFloat($(this).closest('.haiWrapper').find('input[name="hai-prod-id"]').val());
                    let variation = parseFloat($(this).closest('.haiWrapper').find('.var_select').find(":selected").val() || 0);
                    checkedPricesU.push(priceU);
                    checkedPricesWc.push(priceWc);
                    let prod = {prodId: prodId, priceU: priceU, variation: variation}
                    checkedProds.push(prod);
                }
            });

            let totalU = checkedPricesU.reduce((a, b) => a + b, 0);
            let totalWc = checkedPricesWc.reduce((a, b) => a + b, 0);
        
            $('#hai-uprice').text(price + totalU);
            $('#hai-comparePrice').text(price + totalWc);
            
        }

        $('.hai-widget').on('change', 'input[type="checkbox"]', checkPrices);

        let continueAddToCart = false;

        document.querySelector('button[name="add-to-cart"], button.add_to_cart_button').addEventListener("click", function(e){
            if (!continueAddToCart) {
                e.preventDefault();

                let formData = new FormData();
                /*let quantity = parseFloat($('input[name="quantity"]').val());*/
                let funnel_id = jQuery('[name="hai_funnel_id"]')[0].value;
                let card_id = jQuery('[name="hai_card_id"]')[0].value;

                formData.set('action', 'hai_add_to_cart');
                formData.set('checkedProds', JSON.stringify(checkedProds));
                /*formData.set('quantity', quantity);*/
                formData.set('funnel_id', funnel_id);
                formData.set('card_id', card_id);
                ajaxFrontendFormdata(formData, function (data) {
                    continueAddToCart = true;
                    e.target.click();
                });
            } else {
                continueAddToCart = false;
            }
        }, true);

        $(document).on('change', '.upsellWrapper input[type="checkbox"]', function(e){

            if ($(this).is(':checked')){
                let formData = new FormData();
                let product_id = jQuery(this).parents('.upsellWrapper').find('[name="hai-prod-id"]').val();
                let trigger_id = document.getElementById("hai_product_id").value;
                let funnel_id = jQuery('[name="hai_funnel_id"]')[0].value;
                let card_id = jQuery('[name="hai_card_id"]')[0].value;
                
                //console.log(`${formData}\n${product_id}\n${trigger_id}\n${funnel_id}\n${card_id}`);

                formData.set('action', 'hai_funnel_click');
                formData.set('funnel', JSON.stringify({product_id:product_id, trigger_id:trigger_id, funnel_id: funnel_id, card_id:card_id}));

                ajaxFrontendFormdata(formData, function(){});
            }}
        );
        
        checkPrices();
    }

    function ajaxFrontendFormdata(formData, callback) {

        $.ajax({
            url: hai_ajax_object.ajax_url,
            type: 'POST',
            data: formData,
            cache: false,
            processData: false,
            contentType: false,
            success: function (data) {
                callback(data);
            },
            error: function (data) {
                console.log(data);
            }
        });

    }

    /*POPUP*/

    function hai_popup_script(){
        $('.hai-popup button.add-to-cart-button').click(function(e) {
                e.preventDefault();
                $('.hai-product-in-cart').removeClass('show');

                let formData1 = new FormData();

                let trigger_id = document.getElementById("hai_product_id").value;
                let funnel_id = jQuery('[name="hai_funnel_id"]')[0].value;
                let card_id = jQuery('[name="hai_card_id"]')[0].value;
                let product_id = $(this).data('product-id');
                
                formData1.set('action', 'hai_funnel_click');
                formData1.set('funnel', JSON.stringify({product_id:product_id, trigger_id:trigger_id, funnel_id: funnel_id, card_id:card_id}));
        
                ajaxFrontendFormdata(formData1, function(){});

                let formData = new FormData();
                let quantity = parseFloat($(this).closest('.product').find('input[name="quantity"]').val());
                let priceU = parseFloat($(this).closest('.product').find('.hai-price-u').data('price') || 0);
                let checkedProducts = {
                    prodId: product_id,
                    priceU: priceU,
                };

                if($(this).closest('.product').find('.hai-variation-selector').length > 0){
                    /*VARIATION*/
                    const product = hai_variable_products.find(p => p.id == product_id);
                    const { id, variations, attributes, attribute_terms } = product;
                    const selectedAttributes = {};
                    for (const attr in attributes) {
                        const select = document.getElementById(`hai-product-${id}-${attr}-select`);
                        if(!select){continue;}
                        selectedAttributes['attribute_'+select.name] = {slug: select.value, name: jQuery(select).find(':selected').text()};
                    }

                    const selectedVariation = variations.find(variation => {
                        return Object.keys(selectedAttributes).every(attr => {
                            const attrValue = variation.attributes[`attribute_${encodeURI(attr)}`];
                            return attrValue === selectedAttributes[attr] || !attrValue;
                        });
                    });

                    if (selectedVariation) {
                        checkedProducts.variation = selectedVariation.variation_id;
                        checkedProducts.attributes = selectedAttributes;
                    } else {
                        alert('Kérjük válasszon ki minden értéket!');
                    }
                    /*VARIATION end*/
                }

                formData.set('action', 'hai_add_to_cart');
                formData.set('checkedProds', JSON.stringify([checkedProducts]));
                formData.set('quantity', quantity || 1);
                formData.set('funnel_id', funnel_id);
                formData.set('card_id', card_id);
                $(this).parents('.hai-popup-card').find('.hai-popup-loader-cont').removeClass('hai-popup-hidden');
                $(this).parents('.hai-popup-card').find('.hai-popup-loader').removeClass('hai-popup-hidden');
                
                ajaxFrontendFormdata(formData, 
                    function (data) {
                    $('.hai-popup-loader').addClass('hai-popup-hidden');
                    $('.hai-product-in-cart').addClass('show');
                    $('.hai-check.icon').hide();
                    $('.hai-success-checkmark').removeClass('hai-popup-hidden');
                    setTimeout(function(){
                        $('.hai-check.icon').show();
                    }, 10);
                    setTimeout(function(){
                        $('.hai-success-checkmark').addClass('hai-popup-hidden');
                        $('.hai-popup-loader-cont').addClass('hai-popup-hidden');
                    }, 1000);
                    window.hai_body.trigger( 'wc_fragment_refresh' );
                }, 
                function(data){
                    $('.hai-popup-loader-cont').addClass('hai-popup-hidden');
                });
        });

        function ajaxFrontendFormdata(formData, callback, error_callback = function(){}) {

            $.ajax({
                url: hai_ajax_object.ajax_url,
                type: 'POST',
                data: formData,
                cache: false,
                processData: false,
                contentType: false,
                success: function (data) {
                    callback(data);
                },
                error: function (data) {
                    error_callback(data);
                }
            });

        }
    }
    if ($('.hai-popup').length > 0){

        hai_popup_script();
    }

});
