<?php
use HAI\Includes\HAI_Setters;
echo '<input type="hidden" id="hai_product_id" name="hai_product_id" value="'.$id.'">';

$i = 0;
global  $woocommerce;
$prods = json_decode( $funnel->products );
( new HAI_Setters() )->funnel_view(["funnel_id"=>$funnel->funnel_id, "card_id"=>$funnel->card_id, "trigger_id"=>$id, "timestamp"=>time()]);

$product_image = wp_get_attachment_image_url($product->get_image_id(), 'full');
if( in_array($_SERVER['SERVER_NAME'], ['dev.cooponline.hu', 'cooponline.hu', 'app.cooponline.hu', 'devapp.cooponline.hu']) ){
    $brandbank_ean = get_post_meta( $id, 'brandbank_ean', true );
    $brandbank_dir = ABSPATH . 'wp-content/uploads/nielseniq_brandbank/';
    if( is_array( $brandbank_ean ) ) $brandbank_ean = $brandbank_ean[0];
    if( strlen($brandbank_ean) > 8 &&  strlen($brandbank_ean) < 13 ){
        $n = strlen($brandbank_ean);
    
        for ($i = $n; $i < 13; $i++) { 
            $brandbank_ean = '0'.$brandbank_ean;
        }
    }
    
    if( file_exists( $brandbank_dir.$brandbank_ean. '.webp') ){
        $product_image = '/wp-content/uploads/nielseniq_brandbank/' .$brandbank_ean. '.webp';
    }
    elseif( isset( $product_image ) && $product_image != '' ){
        $product_image = $product_image;
    }
    else{
        $product_image = '/wp-content/uploads/2024/04/coop-online-webshop.webp';
    }
}
?>

<div class="hai-absolute-container hai-popup" onclick="haiHidePopupOnBg()">
    <div class="hai-popup-container">
        <div class="hai-popup-header">
            <h2 class="hai-product-in-cart"><?php echo $config->title;?></h2>
            <div style="font-size: 30px; cursor: pointer; margin-top: -5px;" onclick="haiHidePopup()">&#x2715;</div>
        </div>
        <div class="hai-popup-scrollable">
            <div class="hai-product-in-cart-container hai-hide-mobil">
                <div class="hai-product-in-cart-image">
                    <div style="aspect-ratio: 1; max-height: 50px; max-width: 50px;"><img
                            src="<?php echo $product_image;?>"
                            alt="Termék kép">
                    </div>
                </div>
                <div class="hai-product-in-cart-name"><?php echo $product->get_title(); ?></div>
                <div class="hai-product-in-cart-button" style="">
                    <div class="hai-product-in-cart-price"><?php echo $product->get_price_html(); ?></div>
                    <a class="hai-product-in-cart-a-button" href="<?php echo wc_get_cart_url(); ?>">Kosár
                        megtekintése</a>
                </div>
            </div>
            <div class="hai-cards-container">
                <!-- Add your product here -->
                <?php 
                $prods_for_variations = [];
                foreach($prods as $p) { 
                $prod = wc_get_product( $p->id );
                if(!$prod){
					continue;
				}
                $wcprice = wc_get_price_to_display($prod);

// PRODUCTS LOOP

if( $prod->get_manage_stock() ) {
    $in_stock = $prod->get_stock_quantity() > 0;
    if( ! $in_stock && $prod->backorders_allowed() ) {
        $in_stock = true;
    }
} else {
    
    $stock_status = $prod->get_stock_status();
    $in_stock = true;
    if( !$prod->is_in_stock() && !$prod->backorders_allowed() ) {
        $in_stock = false;
    }
    if ( ! $prod->is_purchasable() ) {
        $in_stock = false;
    }
}

switch ($p->discount_type) {
    case '1':
        $disc = $wcprice - ( $wcprice * $p->discount_value / 100 );

        $badge = $p->discount_value . '%';
        break;
    
    case '2':
        $disc = $wcprice - $p->discount_value;
        $badge = $p->discount_value . ' Ft';
        break;
    
    default:
        $disc = $wcprice;
        $badge = '';
        break;
    }

//      NEW DROPDOWN MENU IN LINE
$variable_dropdown = "";
$table = "";
$is_variable = $prod->is_type( 'variable' );
if ( $is_variable ) :
    $available_variations = $prod->get_available_variations();
    $attributes = $prod->get_attributes();
    $attribute_terms = [];

    foreach ($attributes as $attribute_name => $attribute) {
        $terms = wc_get_product_terms($prod->get_id(), urldecode($attribute_name), ['fields' => 'all']);
        foreach ($terms as $term) {
            $attribute_terms[$attribute_name][] = [
                'slug' => $term->slug,
                'name' => $term->name
            ];
        }
    }
    foreach ($available_variations as $key => $variation) {
        $wcprice = $variation['display_price'];
        $disc = ($p->discount_type == '1' ? $wcprice - ($wcprice * $p->discount_value / 100) : ($p->discount_type == '2' ? $wcprice - $p->discount_value : $wcprice));
        $available_variations[$key]['disc_price'] = $disc;
    }
    $prods_for_variations[] = [
        'id' => $prod->get_id(),
        'variations' => $available_variations,
        'attributes' => $attributes,
        'attribute_terms' => $attribute_terms,
    ];
    
    ob_start();
    ?>
                <div class="hai-variation-selector">
                    <!-- Dropdowns will be populated dynamically -->
                </div>
                <?php 
    $table = ob_get_clean();    
endif; 
if( in_array($_SERVER['SERVER_NAME'], ['dev.cooponline.hu', 'cooponline.hu', 'app.cooponline.hu', 'devapp.cooponline.hu']) ){
    $product_loop_image_url = wp_get_attachment_image_url($prod->get_image_id(), 'full');
    $brandbank_ean = get_post_meta( $prod->get_id(), 'brandbank_ean', true );
    $brandbank_dir = ABSPATH . 'wp-content/uploads/nielseniq_brandbank/';
    if( is_array( $brandbank_ean ) ) $brandbank_ean = $brandbank_ean[0];
    if( strlen($brandbank_ean) > 8 &&  strlen($brandbank_ean) < 13 ){
        $n = strlen($brandbank_ean);
    
        for ($i = $n; $i < 13; $i++) { 
            $brandbank_ean = '0'.$brandbank_ean;
        }
    }
    
    if( file_exists( $brandbank_dir.$brandbank_ean. '.webp') ){
        $product_loop_image_url = '/wp-content/uploads/nielseniq_brandbank/' .$brandbank_ean. '.webp';
    }
    elseif( isset( $product_loop_image_url ) && $product_loop_image_url != '' ){
        $product_loop_image_url = $product_loop_image_url;
    }
    else{
        $product_loop_image_url = '/wp-content/uploads/2024/04/coop-online-webshop.webp';
    }
    $product_loop_image = '<img width="450" height="450" src="'.$product_loop_image_url.'" class="attachment-woocommerce_thumbnail size-woocommerce_thumbnail" alt="" decoding="async" loading="lazy">';
}
else{
    $product_loop_image = $prod->get_image();
}
    ?>


                <div class="hai-popup-card product" id="hai-product-<?=$prod->get_id();?>">
                    <div class="hai-popup-loader-cont hai-popup-hidden">
                        <span class="hai-popup-loader hai-popup-hidden"></span>
                        <div class="hai-success-checkmark hai-popup-hidden">
                            <div class="hai-check-icon">
                                <span class="hai-icon-line hai-line-tip"></span>
                                <span class="hai-icon-line hai-line-long"></span>
                                <div class="hai-icon-fix"></div>
                            </div>
                        </div>
                    </div>
                    <span>
                        <?php echo $product_loop_image;?>
                        <p class="hai-product-name">
                            <?php echo $prod->get_name() . ($in_stock ? "" : " -- Elfogyott"); ?>
                        </p>
                    </span>
                    <?php echo $table;?>
                    <div class="price-button-container">
                        <p>
                            <span style="color: rgb(82, 196, 26);">

                                <span class="hai-price-u" data-price="<?=$disc?>">
                                    <?php echo $is_variable ? "Kérjük válasszon ki minden értéket!" : wc_price($disc); ?>
                                </span>
                            </span>
                            <span
                                style="color: rgb(204, 204, 204);text-decoration: line-through; <?= $wcprice == $disc ? "display: none !important;" : "" ?>">
                                <span class="hai-price-wc">
                                    <?php echo $is_variable ? "" :  wc_price($wcprice); ?>
                                </span>
                            </span>
                        </p>
                        <button
                            class="hai-btn-cart single_add_to_cart_button button alt wp-element-button add-to-cart-button"
                            data-product-id="<?php echo $p->id; ?>"
                            <?php echo $in_stock && !$is_variable ? "" : " disabled";?>>Kosárba
                            teszem</button>
                    </div>
                </div>
                <?php }?>
            </div>
        </div>
        <div class="hai-mobile-go-to-cart hai-hide-desktop"><a class="hai-product-in-cart-a-button"
                href="<?php echo wc_get_cart_url(); ?>">Kosár
                megtekintése</a></div>
    </div>
</div>

<style>
h2.hai-product-in-cart {
    font-size: 40px;
}

.hai-absolute-container * {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

.hai-absolute-container {
    width: 100vw;
    height: 100vh;
    background-color: #00000050;
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 10px;
    position: fixed;
    z-index: 99999998;
    top: 0;
    left: 0;
}

/* hai-popup-container */
.hai-popup-container {
    width: 80%;
    max-width: 1000px;
    max-height: 80%;
    background-color: #fafafa;
    border-radius: 10px;
    z-index: 99999999;
    overflow-y: hidden;
    padding-bottom: 10px;
}

.hai-variation-selector select {
    padding: 0 8px;
    width: 100%;
}

.hai-variation-selector {
    display: flex;
    flex-direction: column;
    gap: 8px;
    margin-bottom: 8px;
}

.hai-popup-container table.variations tr {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    margin-bottom: 16px;
}

.hai-popup-container table.variations td {
    padding: 0 !important;
}

.hai-popup-container table.variations {
    display: flex;
}

.hai-popup-container table.variations tr select {
    width: 100%;
}

/* hai-popup-header */
.hai-popup-header {
    display: flex;
    align-items: center;
    justify-content: space-between;
    width: 100%;
    background-color: #fafafa;
    padding: 10px;
    max-height: 68px;
    border-bottom: 1px solid gray;
}

.hai-popup-scrollable {
    max-height: calc(80vh - 68px);
    overflow-y: auto;
}

/* hai-display-title */
.hai-display-title {
    background-color: #f2f2f7;
    margin: 0;
    padding: 10px 30px 0px;
    border-top: 1px solid #00000010;
}

/* hai-cards-container */
.hai-cards-container {
    background-color: #f2f2f7;
    height: auto;
    display: flex;
    align-items: stretch;
    justify-content: center;
    flex-wrap: wrap;
    gap: 10px;
    padding: 10px 30px 10px;
    margin: 10px 10px 10px 10px;
}

.hai-product-in-cart-name {
    font-size: 16px;
    display: flex;
    flex-direction: column;
    justify-content: center;
}

/* hai-popup-card */
.hai-popup-card {
    width: calc(25% - 8px);
    padding: 10px;
    background-color: #fafafa;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    align-items: center;
    border-radius: 3px;
}

/* hai-product-img */
.hai-product-img {
    width: 100%;
}

/* hai-btn-cart */
/* .hai-btn-cart {
        background: linear-gradient(to right, #4a60c1 10%, #3985e0);
        border: none;
        border-radius: 10px;
        padding: 10px;
        color: #fafafa;
        font-weight: 700;
        transition: all ease-in-out 100ms;
        display: flex;
        align-items: center;
        gap: 10px;
        cursor: pointer;
    } */

.hai-btn-cart:disabled {
    cursor: not-allowed;
}

/* .hai-btn-cart:hover {
        background: linear-gradient(to right, #6c83e7 10%, #3985e0);
        transform: scale(1.1);
        transition: all ease-in-out 100ms;
    } */

/* Heisenberg */

.hai-product-variations-dropdown select {
    width: 100%
}

.hai-product-name {
    text-align: center;
}

.price-button-container {
    display: flex;
    flex-direction: column;
    justify-content: space-evenly;
    align-items: center;
}

.hai-absolute-container div.product::after {
    display: none !important;
}

.hai-popup-loader {
    width: 48px;
    height: 48px;
    border: 5px solid #FFF;
    border-bottom-color: transparent;
    border-radius: 50%;
    display: inline-block;
    box-sizing: border-box;
    animation: hai_popup_rotation 1s linear infinite;
}

@keyframes hai_popup_rotation {
    0% {
        transform: rotate(0deg);
    }

    100% {
        transform: rotate(360deg);
    }
}

.hai-popup-loader-cont {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    width: 100%;
    height: 100%;
    background: #00000088;
    display: flex;
    justify-content: center;
    align-items: center;
}

.hai-popup-hidden {
    display: none;
}

/**
 * Extracted from: SweetAlert
 * Modified by: Istiak Tridip
 */
.hai-success-checkmark {
    width: 80px;
    height: 115px;
    margin: 0 auto;
}

.hai-success-checkmark .hai-check-icon {
    width: 80px;
    height: 80px;
    position: relative;
    border-radius: 50%;
    box-sizing: content-box;
    /*border: 4px solid #4CAF50;*/
}

.hai-success-checkmark .hai-check-icon::before {
    top: 3px;
    left: -2px;
    width: 30px;
    transform-origin: 100% 50%;
    border-radius: 100px 0 0 100px;
}

.hai-success-checkmark .hai-check-icon::after {
    top: 0;
    left: 30px;
    width: 60px;
    transform-origin: 0 50%;
    border-radius: 0 100px 100px 0;
    animation: hai-rotate-circle 4.25s ease-in;
}

.hai-success-checkmark .hai-check-icon::before,
.hai-success-checkmark .hai-check-icon::after {
    content: '';
    height: 100px;
    position: absolute;
    background: #00000000;
    transform: rotate(-45deg);
}

.hai-success-checkmark .hai-check-icon .hai-icon-line {
    height: 5px;
    background-color: #4CAF50;
    display: block;
    border-radius: 2px;
    position: absolute;
    z-index: 10;
}

.hai-success-checkmark .hai-check-icon .hai-icon-line.hai-line-tip {
    top: 46px;
    left: 14px;
    width: 25px;
    transform: rotate(45deg);
    animation: hai-icon-line-tip 0.75s;
}

.hai-success-checkmark .hai-check-icon .hai-icon-line.hai-line-long {
    top: 38px;
    right: 8px;
    width: 47px;
    transform: rotate(-45deg);
    animation: hai-icon-line-long 0.75s;
}

.hai-success-checkmark .hai-check-icon .hai-icon-circle {
    top: -4px;
    left: -4px;
    z-index: 10;
    width: 80px;
    height: 80px;
    border-radius: 50%;
    position: absolute;
    box-sizing: content-box;
    border: 4px solid rgba(76, 175, 80, .5);
}

.hai-success-checkmark .hai-check-icon .hai-icon-fix {
    top: 8px;
    width: 5px;
    left: 26px;
    z-index: 1;
    height: 85px;
    position: absolute;
    transform: rotate(-45deg);
    background-color: #00000000;
}


@keyframes hai-rotate-circle {
    0% {
        transform: rotate(-45deg);
    }

    5% {
        transform: rotate(-45deg);
    }

    12% {
        transform: rotate(-405deg);
    }

    100% {
        transform: rotate(-405deg);
    }
}

@keyframes hai-icon-line-tip {
    0% {
        width: 0;
        left: 1px;
        top: 19px;
    }

    54% {
        width: 0;
        left: 1px;
        top: 19px;
    }

    70% {
        width: 50px;
        left: -8px;
        top: 37px;
    }

    84% {
        width: 17px;
        left: 21px;
        top: 48px;
    }

    100% {
        width: 25px;
        left: 14px;
        top: 45px;
    }
}

@keyframes hai-icon-line-long {
    0% {
        width: 0;
        right: 46px;
        top: 54px;
    }

    65% {
        width: 0;
        right: 46px;
        top: 54px;
    }

    84% {
        width: 55px;
        right: 0px;
        top: 35px;
    }

    100% {
        width: 47px;
        right: 8px;
        top: 38px;
    }
}

.hai-product-in-cart-container {
    /*max-height: 80px;*/
    width: 100%;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    gap: 16px;
    padding-left: 20px;
    padding-right: 20px;
    padding-top: 30px;
    padding-bottom: 30px;
    border-bottom: 1px solid gray;
    background-color: white;
}

.hai-product-in-cart-a-button {
    background-color: var(--wp--preset--color--primary);
    border-radius: 0;
    border-width: 0;
    color: var(--wp--preset--color--contrast);
    font-family: inherit;
    font-size: inherit;
    line-height: inherit;
    padding: calc(0.667em + 2px) calc(1.333em + 2px);
    text-decoration: none;
}

.hai-product-in-cart-button {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: flex-end;
    gap: 8px;
    min-width: max-content;
}

@media only screen and (max-width: 800px) {
    .hai-hide-mobil {
        display: none;
    }

    .hai-popup-container {
        height: 100%;
        max-height: 100%;
        width: 100%;
        max-width: 100%;
        border-radius: 0;
    }

    .hai-absolute-container {
        overflow: hidden;
        width: 100vw;
        height: 100vh;
    }

    .hai-hide-desktop {
        display: flex !important;
    }

    .hai-mobile-go-to-cart {
        position: absolute;
        bottom: 0;
        width: 100%;
        background-color: white;
        display: flex;
        flex-direction: row;
        justify-content: center;
        padding: 8px 24px;
    }

    .hai-mobile-go-to-cart a {
        margin-bottom: 64px;
        border: 2px solid black;
        border-radius: 5px;
        color: black;
        width: 100%;
        text-align: center;
        font-weight: bold;
    }

    .hai-cards-container {
        flex-direction: row;
    }

    .hai-popup-card {
        width: calc(50% - 8px);
    }

    .hai-popup-scrollable {
        max-height: 80%;
    }

    .hai-cards-container {
        padding: 0;
    }

    .hai-product-in-cart {
        font-size: 25px !important;
    }
}

.hai-hide-desktop {
    display: none;
}
</style>

<?php /*Csak a syntax highlight miatt.*/
ob_start(); 
?>
<script>
<?php $asd = ob_get_clean(); ?>
<?php ob_start(); ?>
const hai_html = document.querySelector('html');
const hai_body = document.body;
hai_html.style.overflow = "hidden";
hai_html.style.height = "100vh";
hai_body.style.overflow = "hidden";
hai_body.style.height = "100vh";

function haiHidePopup() {
    if (hai_popup_ajax) {
        window.hai_body.trigger('wc_fragment_refresh');
    }
    document.querySelector('.hai-absolute-container').remove();
    hai_html.style.overflow = "";
    hai_html.style.height = "";
    hai_body.style.overflow = "";
    hai_body.style.height = "";
}

function haiHidePopupOnBg() {
    if (event.target === document.querySelector('.hai-absolute-container')) {
        if (hai_popup_ajax) {
            window.hai_body.trigger('wc_fragment_refresh');
        }
        document.querySelector('.hai-absolute-container').remove();
        hai_html.style.overflow = "";
        hai_html.style.height = "";
        hai_body.style.overflow = "";
        hai_body.style.height = "";
    }
}

const hai_variable_products = [
    <?php
foreach ($prods_for_variations as $product){
    ?> {
        id: '<?= $product['id'] ?>',
        variations: <?= json_encode($product['variations']) ?>,
        attributes: <?= json_encode($product['attributes']) ?>,
        attribute_terms: <?= json_encode($product['attribute_terms']) ?>
    },
    <?php
}
?>
];

hai_variable_products.forEach(product => {
    const {
        id,
        variations,
        attributes,
        attribute_terms
    } = product;
    const selectorDiv = document.querySelector(`#hai-product-${id} .hai-variation-selector`);
    const priceDisplayDisc = document.querySelector(`#hai-product-${id} .hai-price-u`);
    const priceDisplayDef = document.querySelector(`#hai-product-${id} .hai-price-wc`);
    const addToCartButton = document.querySelector(`#hai-product-${id} .add-to-cart-button`);

    function createDropdown(attributeName) {
        const select = document.createElement('select');
        select.id = `hai-product-${id}-${attributeName}-select`;
        select.name = attributeName;
        select.onchange = () => updateOptions(attributeName);
        const option = document.createElement('option');
        option.value = '';
        option.text = `<?= esc_html__('Choose an option', 'woocommerce'); ?>`;
        select.add(option);
        return select;
    }

    function populateInitialOptions() {
        for (const attr in attributes) {

            const uniqueValues = new Map();
            if (attribute_terms[attr]) {
                attribute_terms[attr].forEach(term => {
                    // Check if at least one variation has the term slug
                    const hasTermInVariations = variations.some(variation =>
                        variation.attributes['attribute_' + attr] === term.slug || variation
                        .attributes['attribute_' + attr] === ""
                    );

                    // If term is found in variations or there are no variations with that attribute, add it to uniqueValues
                    if (hasTermInVariations) {
                        uniqueValues.set(term.slug, term.name);
                    }
                });
            }

            if (uniqueValues.size != 0) {
                const dropdown = createDropdown(attr);
                selectorDiv.appendChild(dropdown);
                uniqueValues.forEach((name, slug) => {
                    const option = document.createElement('option');
                    option.value = decodeURI(slug);
                    option.text = decodeURI(name);
                    dropdown.add(option);
                });
            }
        }
    }

    populateInitialOptions();

    function updateOptions(changedAttribute) {
        const selectedAttributes = {};
        let allSelected = true;

        for (const attr in attributes) {
            const select = document.getElementById(`hai-product-${id}-${attr}-select`);
            if (!select) {
                continue
            }
            selectedAttributes[attr] = select.value;
            if (!select.value && attr !== changedAttribute) {
                allSelected = false;
            }
        }

        const availableVariations = filterVariations(variations, selectedAttributes);

        for (const attr in attributes) {
            if (attr !== changedAttribute) {
                updateDropdown(attr, availableVariations, selectedAttributes, attr === Object.keys(attributes)[
                    0]);
            }
        }

        updatePriceDisplay(availableVariations, selectedAttributes, allSelected);
    }

    function filterVariations(variations, selectedAttributes) {
        return variations.filter(variation => {
            return Object.keys(selectedAttributes).every(attr => {
                const selectedValue = selectedAttributes[attr];
                if (!selectedValue) return true;
                const attrValue = variation.attributes[`attribute_${attr}`];
                return attrValue === selectedValue || attrValue == "";
            });
        });
    }

    function updateDropdown(attributeName, availableVariations, selectedAttributes, isFirstDropdown) {
        const select = document.getElementById(`hai-product-${id}-${attributeName}-select`);
        if (!select) return;
        const selectedValue = select.value;
        select.innerHTML = `<option value=""><?= esc_html__('Choose an option', 'woocommerce'); ?></option>`;

        const uniqueValues = new Map();
        if (isFirstDropdown) {
            // Populate first dropdown with all possible values
            if (attribute_terms[attributeName]) {
                attribute_terms[attributeName].forEach(term => {
                    // Check if at least one variation has the term slug
                    const hasTermInVariations = variations.some(variation =>
                        variation.attributes['attribute_' + attr] === term.slug || variation
                        .attributes['attribute_' + attr] === ""
                    );

                    // If term is found in variations or there are no variations with that attribute, add it to uniqueValues
                    if (hasTermInVariations || !variations.some(variation => variation.attributes
                            .hasOwnProperty('attribute_' + attributeName))) {
                        uniqueValues.set(term.slug, term.name);
                    }
                });
            }
        } else {
            availableVariations.forEach(variation => {
                const value = variation.attributes[`attribute_${attributeName}`];
                if (value) {
                    const term = attribute_terms[attributeName]?.find(term => term.slug === value);
                    if (term) {
                        uniqueValues.set(term.slug, term.name);
                    }
                } else {
                    // If value is null, add all possible values for this attribute
                    if (attribute_terms[attributeName]) {
                        attribute_terms[attributeName].forEach(term => {
                            // Check if at least one variation has the term slug
                            const hasTermInVariations = variations.some(variation =>
                                variation.attributes['attribute_' + attr] === term.slug ||
                                variation.attributes['attribute_' + attr] === ""
                            );

                            // If term is found in variations or there are no variations with that attribute, add it to uniqueValues
                            if (hasTermInVariations || !variations.some(variation => variation
                                    .attributes.hasOwnProperty('attribute_' + attributeName))) {
                                uniqueValues.set(term.slug, term.name);
                            }
                        });
                    }
                }
            });
        }

        uniqueValues.forEach((name, slug) => {
            const option = document.createElement('option');
            option.value = decodeURI(slug);
            option.text = decodeURI(name);
            if (slug === selectedValue) {
                option.selected = true;
            }
            select.add(option);
        });

        // Restore the previously selected value if it exists
        const isPrevValueExist = Array.from(select.options).some(option => option.value === selectedValue);
        select.value = isPrevValueExist ? selectedValue : '';
    }

    function updatePriceDisplay(availableVariations, selectedAttributes, allSelected) {
        if (!allSelected) {
            priceDisplayDisc.innerText = 'Kérjük válasszon ki minden értéket!';
            priceDisplayDef.innerText = '';
            addToCartButton.disabled = true;
            return;
        }

        const selectedVariation = availableVariations.find(variation => {
            return Object.keys(selectedAttributes).every(attr => {
                const attrValue = variation.attributes[`attribute_${attr}`];
                return attrValue === selectedAttributes[attr] || attrValue === '';
            });
        });

        if (selectedVariation) {
            priceDisplayDef.innerHTML =
                `${hai_wc_price(selectedVariation.display_price, hai_wc_settings_args)}`;
            priceDisplayDisc.innerHTML = `${hai_wc_price(selectedVariation.disc_price, hai_wc_settings_args)}`;
            priceDisplayDisc.dataset.price = selectedVariation.disc_price;
            addToCartButton.disabled = false;
        } else {
            priceDisplayDisc.innerText = 'Kérjük válasszon ki minden értéket!';
            priceDisplayDef.innerText = '';
            addToCartButton.disabled = true;
        }
    }
});

<?php $popup_script = ob_get_clean(); ?>