<?php

namespace HAI\Includes;

use WP_REST_Controller;
use HAI\Includes\HAI_Settings_Route;

class HAI_Api extends WP_REST_Controller {

    /**
     * Construct Function
     */
    public function __construct() {
        add_action( 'rest_api_init', [ $this, 'register_routes' ] );
    }

    /**
     * Register API routes
     */
    public function register_routes() {
        ( new HAI_Settings_Route() )->register_routes();
    }

}