<?php
use HAI\Includes\HAI_Connect_helios;
$postfields['apikey'] = get_option( 'hai_api_token' );
$res = ( new HAI_Connect_helios('getNewsletterLists') )->connect($postfields);
?>
<form method="POST">
    <input type="hidden" name="type" value="newsletter_group">
    <table class="form-table" role="presentation">
        <tbody>
            <tr>
                <th scope="row">A rendelés leadásakor lehetőséget adunk a felhasználóknak, hogy feliratkozzanak a hírlevelünkre</th>
                <td>
                    <fieldset>
                        <label><input type="checkbox" name="newsletter_is_on" id="newsletter_is_on"
                                <?= get_option('hai_newsletter_is_on') ? "checked" : ""?>>
                                Rendeléskor feliratkozás engedélyezése</label>
                        <p class="description">Megjelenik egy checkbox a pénztár oldalon a rendelés feladása gomb
                            felett.</p>
                    </fieldset>
                </td>
            </tr>
            <tr>
                <th scope="row">Email cím mező előrehozása engedélyezése</th>
                <td>
                    <fieldset>
                        <label><input type="checkbox" name="newsletter_email_field_first"
                                id="newsletter_email_field_first"
                                <?= get_option('hai_newsletter_email_field_first') ? "checked" : ""?>>
                            Email cím mező előrehozása</label>
                        <p class="description">Az email cím mezőt elsőként jeleníti meg a pénztár oldalon.</p>
                    </fieldset>
                </td>
            </tr>
            <tr>
                <th scope="row">Alapértelmezetten bepipálva</th>
                <td>
                    <fieldset>
                        <label><input type="checkbox" name="newsletter_default_true" id="newsletter_default_true"
                                <?= get_option('hai_newsletter_default_true') ? "checked" : ""?>>
                            Alapértelmezetten bepipálva</label>
                    </fieldset>
                </td>
            </tr>
            <tr>
                <th scope="row">Hírlevél feliratkozó checkbox szövege</th>
                <td>
                    <fieldset>
                        <input style="width: 400px;" type="text" name="newsletter_checkbox_text" id="newsletter_checkbox_text"
                            value="<?= get_option('hai_newsletter_checkbox_text') ? get_option('hai_newsletter_checkbox_text') : "Feliratkozok a hírlevélre"?>">
                        <p class="description"></p>
                    </fieldset>
                </td>
            </tr>
            <tr>
                <th scope="row">Melyik csoportba iratkozzanak fel a rendelést feladók?</th>
                <td>
                    <fieldset>
                        <p><label>
                                <select name="newsletter_default_group">
                                    <?php foreach($res as $row){ ?>
                                    <option value=<?=$row->id?>
                                        <?= get_option('hai_newsletter_default_group') == $row->id ? "selected" : ""?>>
                                        <?=$row->name?></option>
                                    <?php }?>
                                </select></label>
                        </p>
                    </fieldset>
                </td>
            </tr>

        </tbody>
    </table>

    <p></p>

    <input type="submit" value="Mentés" class="button button-primary">
</form>